<?php
/**
 * Xcart Order model
 *
 * @category   Turnkeye
 * @package    Turnkeye_Xcartorders
 * @author     Viacheslav Fedorenko <v.fedorenko@turnkeye.com>
 */

class Turnkeye_Xcartorders_Model_Order extends Mage_Core_Model_Abstract
{

    /**
     * Internal constructor not depended on params. Can be used for object initialization
     */
    public function _construct()
    {
        parent::_construct();
        $this->_init('turnkeye_xcartorders/order');
    }

    public function getCustomerName()
    {
        if ($this->getFirstname()) {
            $customerName = $this->getFirstname() . ' ' . $this->getLastname();
        }
        else {
            $customerName = Mage::helper('sales')->__('Guest');
        }
        return $customerName;
    }

    public function getBillingAddress()
    {
        $arr = array(
            'firstname' => $this->getData('firstname'),
            'lastname' => $this->getData('lastname'),
            'street' => $this->getData('b_address'),
            'city' => $this->getData('b_city'),
            'country_id' => $this->getData('b_country'),
            'region' => $this->getData('b_state'),
            'postcode' => $this->getData('b_zipcode'),
            'telephone' => $this->getData('phone'),
        );
        return Mage::getModel('sales/order_address')->setData($arr);
    }

    public function getShippingAddress()
    {
        $arr = array(
            'firstname' => $this->getData('s_firstname'),
            'lastname' => $this->getData('s_lastname'),
            'street' => $this->getData('s_address'),
            'city' => $this->getData('s_city'),
            'country_id' => $this->getData('s_country'),
            'region' => $this->getData('s_state'),
            'postcode' => $this->getData('s_zipcode'),
            'telephone' => $this->getData('phone'),
        );
        return Mage::getModel('sales/order_address')->setData($arr);
    }

    public function getStatusLabel()
    {
        $opt = Mage::getSingleton('turnkeye_xcartorders/order_config')->getStatuses();
        return $opt[$this->getStatus()];
    }

    /**
     * get order items
     *
     * @return Turnkeye_Xcartorders_Model_Resource_Order_Detail_Collection
     */
    public function getItems()
    {
        return Mage::getModel('turnkeye_xcartorders/order_detail')->getCollection()->addFieldToFilter('orderid', $this->getId());
    }


}